
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title CBNZ, CBZ

@encoding(t11) {

    @half 1 0 1 1 1 0 i(1) 1 imm5(5) Rn(3)

    @syntax <Rn> <label>

    @conv {

        Rn = Register(Rn)
        label = ZeroExtend(i:imm5:'0', 7, 32);

    }

    @hooks {

        fetch = help_fetching_with_instruction_cb_n_z
        link = handle_comp_and_branch_if_true_as_link
        post = post_process_comp_and_branch_instructions

    }

}

@encoding(t12) {

    @half 1 0 1 1 0 0 i(1) 1 imm5(5) Rn(3)

    @syntax "cbz" <Rn> <label>

    @conv {

        Rn = Register(Rn)
        label = ZeroExtend(i:imm5:'0', 7, 32);

    }

    @hooks {

        fetch = help_fetching_with_instruction_cb_n_z
        link = handle_comp_and_branch_if_true_as_link
        post = post_process_comp_and_branch_instructions

    }

}
