
/* Chrysalide - Outil d'analyse de fichiers binaires
 * ##FILE## - traduction d'instructions ARMv7
 *
 * Copyright (C) 2014 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  Chrysalide is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Chrysalide is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


@title TST (register)

@encoding(t1) {

    @half 0 1 0 0 0 0 1 0 0 0 Rm(3) Rn(3)

    @syntax <Rn> <Rm>

    @conv {

        Rn = Register(Rn)
        Rm = Register(Rm)

    }

}

@encoding(T2) {

    @word 1 1 1 0 1 0 1 0 0 0 0 1 Rn(4) 0 imm3(3) 1 1 1 1 imm2(2) type(2) Rm(4)

    @syntax <Rn> <Rm> <?shift>

    @conv {

        Rn = Register(Rn)
        Rm = Register(Rm)
        shift = DecodeImmShift(type, imm3:imm2)

    }

    @rules {

        //if n IN {13,15} || m IN {13,15} then UNPREDICTABLE

    }

}

@encoding(A1) {

    @word cond(4) 0 0 0 1 0 0 0 1 Rn(4) 0 0 0 0 imm5(5) type(2) 0 Rm(4)

    @syntax {c} <Rn> <Rm> <?shift>

    @conv {

        c = Condition(cond)
        Rn = Register(Rn)
        Rm = Register(Rm)
        shift = DecodeImmShift(type, imm5)

    }

    @rules {

        //if ((Rd == '1111') && (S == '1')) ; see SUBS PC, LR and related instructions

    }

}
