
/* Chrysalide - Outil d'analyse de fichiers binaires
 * translate.h - prototypes pour les environnements de traduction d'instructions Dalvik
 *
 * Copyright (C) 2010-2013 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ANALYSIS_DECOMP_RTL_DALVIK_TRANSLATE_H
#define _ANALYSIS_DECOMP_RTL_DALVIK_TRANSLATE_H


#include "../../translate.h"



/* Décompile une instruction de type 'aget'. */
GDecInstruction *dalvik_decomp_instr_aget(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'aput'. */
GDecInstruction *dalvik_decomp_instr_aput(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'array-length'. */
GDecInstruction *dalvik_decomp_instr_array_length(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'const'. */
GDecInstruction *dalvik_decomp_instr_const(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'const-string'. */
GDecInstruction *dalvik_decomp_instr_const_str(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'iget'. */
GDecInstruction *dalvik_decomp_instr_iget(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'invoke-direct'. */
GDecInstruction *dalvik_decomp_instr_invoke_direct(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'invoke-static'. */
GDecInstruction *dalvik_decomp_instr_invoke_static(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'invoke-virtual'. */
GDecInstruction *dalvik_decomp_instr_invoke_virtual(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'iput'. */
GDecInstruction *dalvik_decomp_instr_iput(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'move'. */
GDecInstruction *dalvik_decomp_instr_move(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'move-object'. */
GDecInstruction *dalvik_decomp_instr_move_object(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'move-result'. */
GDecInstruction *dalvik_decomp_instr_move_result(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'new-instance'. */
GDecInstruction *dalvik_decomp_instr_new_instance(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'return'. */
GDecInstruction *dalvik_decomp_instr_return(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'return-void'. */
GDecInstruction *dalvik_decomp_instr_return_void(const GArchInstruction *, GDecContext *);


/* Décompile une instruction de type 'opérations arithmétiques'. */
GDecInstruction *dalvik_decomp_instr_arithm(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'opérations arithmétiques'. */
GDecInstruction *dalvik_decomp_instr_arithm_2addr(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de type 'opérations arithmétiques'. */
GDecInstruction *dalvik_decomp_instr_arithm_lit(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de branchement conditionnel. */
GDecInstruction *dalvik_decomp_instr_if(const GArchInstruction *, GDecContext *);

/* Décompile une instruction de branchement conditionnel. */
GDecInstruction *dalvik_decomp_instr_if_zero(const GArchInstruction *, GDecContext *);

/* Décompile une instruction d'aiguillages multiples du flux. */
GDecInstruction *dalvik_decomp_instr_switch(const GArchInstruction *, GDecContext *);



#endif  /* _ANALYSIS_DECOMP_RTL_DALVIK_TRANSLATE_H */
