
/* Chrysalide - Outil d'analyse de fichiers binaires
 * target.h - prototypes pour les opérandes visant une adresse de code
 *
 * Copyright (C) 2010 Cyrille Bagard
 *
 *  This file is part of Chrysalide.
 *
 *  OpenIDA is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  OpenIDA is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 */


#ifndef _ARCH_DALVIK_OPERANDS_TARGET_H
#define _ARCH_DALVIK_OPERANDS_TARGET_H


#include <glib-object.h>


#include "../../immediate.h"



#define G_TYPE_DALVIK_TARGET_OPERAND                  g_dalvik_target_operand_get_type()
#define G_DALVIK_TARGET_OPERAND(obj)                  (G_TYPE_CHECK_INSTANCE_CAST((obj), g_dalvik_target_operand_get_type(), GDalvikTargetOperand))
#define G_IS_DALVIK_TARGET_OPERAND(obj)               (G_TYPE_CHECK_INSTANCE_TYPE((obj), g_dalvik_target_operand_get_type()))
#define G_DALVIK_TARGET_OPERAND_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST((klass), G_TYPE_DALVIK_TARGET_OPERAND, GDalvikTargetOperandClass))
#define G_IS_DALVIK_TARGET_OPERAND_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE((klass), G_TYPE_DALVIK_TARGET_OPERAND))
#define G_DALVIK_TARGET_OPERAND_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS((obj), G_TYPE_DALVIK_TARGET_OPERAND, GDalvikTargetOperandClass))


/* Définition d'un opérande visant une adresse de code Dalvik (instance) */
typedef struct _GDalvikTargetOperand GDalvikTargetOperand;

/* Définition d'un opérande visant une adresse de code Dalvik (classe) */
typedef struct _GDalvikTargetOperandClass GDalvikTargetOperandClass;


/* Indique le type défini par la GLib pour un opérande de ciblage de code Dalvik. */
GType g_dalvik_target_operand_get_type(void);

/* Crée un opérande visant un instruction Dalvik. */
GArchOperand *g_dalvik_target_operand_new(const GBinContent *, vmpa2t *, MemoryDataSize, SourceEndian, const vmpa2t *);

/* Fournit l'adresse représentée par une opérande Dalvik. */
const GImmOperand *g_dalvik_target_operand_get_value(const GDalvikTargetOperand *);



#endif  /* _ARCH_DALVIK_OPERANDS_TARGET_H */
